# -*- coding: utf-8 -*-

from enigma import getDesktop
import os
import sys
import time
import codecs


class mainScreen():
    skin = ""  # xml skin
    bdrw = 0   # border and spacing width
    dw = 0     # desktop width
    dh = 0     # desktop height
    ww = 0     # window width
    wh = 0     # window height
    wl = 0     # window left
    wt = 0     # window top
    bw = 0     # button width
    bh = 0     # button height
    lh = 0     # list height
    wd = []    # list widths

    realbw = 140   # real button pixmap width

    def __init__(self, mainTitle, mainVersion, widthsList, mainSize=[0, 0]):
        self.bdrw = 5
        if (mainSize[0] == 0) and (mainSize[1] == 0):
            self.dw = getDesktop(0).size().width()
            self.dh = getDesktop(0).size().height()
        else:
            self.dw = mainSize[0]
            self.dh = mainSize[1]

        self.wl = 200
        self.wt = 100
        self.ww = self.dw - (2 * self.wl)
        self.wh = self.dh - (2 * self.wt)
        self.bw = int((self.ww - (self.bw * 5)) / 4)
        self.bh = 40
        self.lh = int(self.wh - (3 * self.bdrw) - self.bh) - ((2 * self.bdrw) + (2 * self.bh))
        skin = "%s/screens/main.xml" % os.path.dirname(sys.modules[__name__].__file__)
        # f = open(skin, "r")
        # skin = f.read()
        # f.close()

        skin = "%s/screens/main.xml" % os.path.dirname(sys.modules[__name__].__file__)
        with codecs.open(skin, "r", encoding="utf-8") as f:
            self.skin = f.read()

        btnTop = self.wh - self.bdrw - self.bh
        btnDelta = int((self.bw - self.realbw) / 2)
        wdths = []
        dww = self.ww - self.bdrw
        for i in widthsList:
            wdths.append(int(i * dww / 100) - self.bdrw)

        self.wd = wdths
        self.skin = skin % (self.wl, self.wt, self.ww, self.wh, mainTitle, mainVersion,  # main window position, size & title
                            wdths[0], self.lh,   # list  # 0: size
                            (2 * self.bdrw) + self.lh, wdths[0],   # namelabel label: top and width
                            (3 * self.bdrw) + self.lh + self.bh, wdths[0],  # iplabel label: top and width
                            self.bdrw + btnDelta, btnTop, self.bw, self.bh,  # button pixmap  #0: position & size
                            (self.bdrw * 2) + self.bw + btnDelta, btnTop, self.bw, self.bh,  # button pixmap  #1: position & size
                            (self.bdrw * 3) + (self.bw * 2) + btnDelta, btnTop, self.bw, self.bh,  # button pixmap  #1: position & size
                            (self.bdrw * 4) + (self.bw * 3) + btnDelta, btnTop, self.bw, self.bh,  # button pixmap  #1: position & size
                            btnTop, self.bw, self.bh,  # button  #0: top & size
                            (self.bdrw * 2) + self.bw, btnTop, self.bw, self.bh,  # button  #1: position & size
                            (self.bdrw * 3) + (self.bw * 2), btnTop, self.bw, self.bh,  # button  #2: position & size
                            (self.bdrw * 4) + (self.bw * 3), btnTop, self.bw, self.bh)  # button  #3: position & size

        # print('skin is:', self.skin)
        skin = "%s/screens/main.data.xml" % os.path.dirname(sys.modules[__name__].__file__)
        f = open(skin, "w")
        f.write(self.skin)
        f.close()


class theTime:
    timetoLog = time.strftime("%d.%m.%YT%H:%M:%S", time.localtime())
    lastMsg = ""

    def getTimeStr(self):
        timetoLog = time.strftime("%d.%m.%YT%H:%M:%S", time.localtime())
        return timetoLog

    def doLog(self, msg, enabled=False):
        self.lastMsg = "[noipdyndns " + self.getTimeStr() + "] " + str(msg)
        if enabled:
            try:
                # For compatibility with both Python 2 and 3
                with open("/tmp/noipdyndns.log", 'a+') as file:
                    file.write(self.lastMsg + "\n")
            except IOError as e:
                print("Error writing to log file: ", e)

        return self.lastMsg
